//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Fri Apr  6 08:30:12 2012 by ROOT version 5.32/00
// from TTree tree/tree
// found on file: www/data/lhcttbar.root
//////////////////////////////////////////////////////////

#ifndef WebSelector_h
#define WebSelector_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <TSelector.h>

// Header file for the classes stored in the TTree if any.
#include <TClonesArray.h>
#include <TObject.h>
#include <TAttLine.h>
#include <TParticle.h>

////////////
#include "Config.h"
#include "TH1F.h"

// Fixed size dimensions of array or collections stored in the TTree if any.
const Int_t kMaxgenParticles = 791;
const Int_t kMaxelectrons = 2;
const Int_t kMaxmuons = 1;
const Int_t kMaxphotons = 2;
const Int_t kMaxjets = 8;

class WebSelector : public TSelector {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain

   // Declaration of leaf types
  TClonesArray* muons;
  TClonesArray* electrons;
  TClonesArray* photons;
  TClonesArray* jets;
  double met;
  double metPhi;
  double sumPt;
  double trueMet;
  double trueMetPhi;
  double trueSumPt;
  Config config;

  // hists
  TH1F* ptMu1;
  TH1F* ptEl1;
  TH1F* ptPh1;
  TH1F* ptJet1;

  TH1F* histMet;
  TH1F* histHt;
  TH1F* histSt;
  TH1F* histM;
  TH1F* histSmin;
  TH1F* histMDiMu;
  TH1F* histMDiEl;
  TH1F* histMDiJet;
  TH1F* histMDiPh;

   WebSelector(TTree * /*tree*/ =0);
   virtual ~WebSelector() { };
   virtual Int_t   Version() const { return 2; };
   virtual void    Begin(TTree *tree);
   virtual void    SlaveBegin(TTree *tree);
   virtual void    Init(TTree *tree);
   virtual Bool_t  Notify();
   virtual Bool_t  Process(Long64_t entry);
   virtual Int_t   GetEntry(Long64_t entry, Int_t getall = 0) { return fChain ? fChain->GetTree()->GetEntry(entry, getall) : 0; }
   virtual void    SetOption(const char *option) { fOption = option; }
   virtual void    SetObject(TObject *obj) { fObject = obj; }
   virtual void    SetInputList(TList *input) { fInput = input; }
   virtual TList  *GetOutputList() const { return fOutput; }
   virtual void    SlaveTerminate();
   virtual void    Terminate();

   ClassDef(WebSelector,0);
};

#endif

#ifdef WebSelector_cxx

WebSelector::WebSelector(TTree* tree):
  fChain(0),config()
{
  muons = new TClonesArray("TParticle");
  electrons = new TClonesArray("TParticle");
  photons = new TClonesArray("TParticle");
  jets = new TClonesArray("TParticle");
  met=0.0;
  metPhi=0.0;
  sumPt=0.0;
  trueMet=0.0;
  trueMetPhi=0.0;
  trueSumPt=0.0;
}

void WebSelector::Init(TTree *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the branch addresses and branch
   // pointers of the tree will be set.
   // It is normally not necessary to make changes to the generated
   // code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running on PROOF
   // (once per file to be processed).

   // Set branch addresses and branch pointers
  if (!tree) return;
  fChain = tree;

  fChain->SetBranchAddress("muons",&muons);
  fChain->SetBranchAddress("electrons",&electrons);
  fChain->SetBranchAddress("photons",&photons);
  fChain->SetBranchAddress("jets",&jets);
  fChain->SetBranchAddress("met",&met);
  fChain->SetBranchAddress("metPhi",&metPhi);
  fChain->SetBranchAddress("sumPt",&sumPt);
  fChain->SetBranchAddress("trueMet",&trueMet);
  fChain->SetBranchAddress("trueMetPhi",&trueMetPhi);
  fChain->SetBranchAddress("trueSumPt",&trueSumPt);
}

Bool_t WebSelector::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. It is normally not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed. The return value is currently not used.

   return kTRUE;
}

#endif // #ifdef WebSelector_cxx
