#ifndef SPODS_YamlReader
#define SPODS_YamlReader

#include <string>
#include <sstream>
#include <utility>
#include <yaml-cpp/yaml.h>

class YamlReader
{
private:
   std::string data;
   std::stringstream stringstream;
   YAML::Parser parser;
   YAML::Node doc;
public:
   YamlReader(const char* indata);
   bool GetNextDoc();
   std::vector<std::pair<float,float> > GetVectorOfPairs(std::string);
   std::vector<float> GetVectorOfFloats(std::string);

   double GetValueSubMap(std::string mapName, std::string key)
   {
    if (const YAML::Node *node = doc.FindValue(mapName))
    {
      if(const YAML::Node *node2 = node->FindValue(key))
      {
	double value;
	*node2 >> value;
	return value;
      }
      else
      {
	std::cout << "Config Error: key: " << mapName << " not found in "<<
		"mapName"<< mapName <<"!\n";
	throw;
	double tmp;
	return tmp;
      };
    }
    else
    {
	std::cout << "Config Error: mapName: " << mapName << " not found!\n";
	throw;
	double tmp;
	return tmp;
    }
   };

   int GetValueSubMapInt(std::string mapName, std::string key)
   {
    if (const YAML::Node *node = doc.FindValue(mapName))
    {
      if(const YAML::Node *node2 = node->FindValue(key))
      {
	double value;
	*node2 >> value;
	return value;
      }
      else
      {
	std::cout << "Config Error: key: " << mapName << " not found in "<<
		"mapName"<< mapName <<"!\n";
	throw;
	double tmp;
	return tmp;
      };
    }
    else
    {
	std::cout << "Config Error: mapName: " << mapName << " not found!\n";
	throw;
	double tmp;
	return tmp;
    }
   };
};

#endif


