#include "Python.h"
#include "include/WebHEPInterface.h"

static PyObject *
WebHEP_run(PyObject *self, PyObject *args)
{
  fprintf(stderr, "Starting WebHEP.run()\n");
  const char* inJson;
  if(!PyArg_ParseTuple(args,"s",&inJson))
  {
        fprintf(stderr, "Error: PyArg_ParseTuple returns NULL\n");
	return NULL;
  }

  const char* outJson = runWebHEP(inJson);

  //fprintf(stderr,"WebHEP_run result (c_str): \n");
  //fprintf(stderr,outJson);
  //fprintf(stderr,"\n");

  PyObject* result = Py_BuildValue("s",outJson);
  //PyObject_Print(result,stderr,0);

  fprintf(stderr, "Finishing WebHEP.run()\n");
  return result;
}

static PyObject *
WebHEP_test(PyObject *self, PyObject *args)
{
  fprintf(stderr, "Starting WebHEP.test()\n");
  const char* inJson;
  if(!PyArg_ParseTuple(args,"s",&inJson))
  {
        fprintf(stderr, "Error: PyArg_ParseTuple returns NULL\n");
	return NULL;
  }

  fprintf(stderr, "WebHEP.test(): PyArg Parsed\n");

  const char* outJson = "it works!";

  fprintf(stderr, "Finishing WebHEP.test()\n");
  return Py_BuildValue("s",outJson);
}


static PyObject *
WebHEP_test2(PyObject *self, PyObject *args)
{
  fprintf(stderr, "Starting WebHEP.test2()\n");
  const char* inJson;
  if(!PyArg_ParseTuple(args,"s",&inJson))
  {
        fprintf(stderr, "Error: PyArg_ParseTuple returns NULL\n");
	return NULL;
  }

  const char* outJson = WebHEPInterfaceTest(inJson);

  fprintf(stderr, "Finishing WebHEP.test()\n");
  return Py_BuildValue("s",outJson);
}

static PyObject *
WebHEP_test3(PyObject *self, PyObject *args)
{
  fprintf(stderr, "Starting WebHEP.test3()\n");
  return NULL;
}

static PyObject *
WebHEP_test4(PyObject *self, PyObject *args)
{
  fprintf(stderr, "Starting WebHEP.test4()\n");
  Py_RETURN_NONE;
}

static PyMethodDef WebHEPMethods[] = 
{
   {"run",WebHEP_run, METH_VARARGS,"Runs a ROOT PROOF Analyzer \n\ttakes a json configuration string as input \n\treturns a json string of histograms as outptut"},
   {"test",WebHEP_test, METH_VARARGS,"Takes a string and passes back a string"},
   {"test2",WebHEP_test2, METH_VARARGS,"Takes a string and passes back a string using WebHEPInterfaceTest()"},
   {"test3",WebHEP_test3, METH_VARARGS,"Does nothing, returns NULL"},
   {"test4",WebHEP_test4, METH_VARARGS,"Does nothing, returns None"},
   {NULL, NULL, 0, NULL}        /* Sentinel */
};

PyMODINIT_FUNC
initWebHEP(void)
{
    (void) Py_InitModule("WebHEP", WebHEPMethods);
}

