
#include "YamlReader.h"
#include <stdlib.h>


YamlReader::YamlReader(const char* fnin):
	data(fnin), stringstream(data), parser(stringstream), doc()
{
	parser.GetNextDocument(doc);
}

bool
YamlReader::GetNextDoc()
{
	return parser.GetNextDocument(doc);
}

std::vector<std::pair<float,float> > 
YamlReader::GetVectorOfPairs(std::string key)
{
    std::vector<std::pair<float,float> > result(1,std::make_pair(10.0,10.0));
    result.clear();

    if (const YAML::Node *node = doc.FindValue(key.c_str()))
    {
      if(node->Type() != YAML::NodeType::Sequence)
      {
	std::cout << "Config Error: " << key << 
		"is a not a list, must be a list of pairs!\n";
	throw;
	return result;
      }
      float first= -99999;
      bool firstDone=false;
      for(YAML::Iterator it=node->begin(); it!=node->end();++it)
      {
	if(it->Type()==YAML::NodeType::Scalar)
	{
	  std::string scalar;
	  *it >> scalar;
	  if(!firstDone)
	  {
	    first = atof(scalar.c_str());
	    firstDone=true;
	  }
	  else
	  {
	    float second = atof(scalar.c_str());
	    result.push_back(std::make_pair(first,second));
	    return result;
	  }
	}
	else if(it->Type()==YAML::NodeType::Sequence)
	{
	  first=-888888;
	  firstDone=false;
	  float second=-888888;
	  bool secondDone=false;
	  for(YAML::Iterator it2=it->begin(); it2 != it->end();++it2)
  	  {
		if(it2->Type() != YAML::NodeType::Scalar)
		{
		  std::cout << "Config Error: " << key << " is not a vector of pairs of scalars!\nMake sure they are scalars!\n";
		  throw;
		}
		std::string scalar;
		*it2 >> scalar;
	  	if(!firstDone)
	  	{
	    	  first = atof(scalar.c_str());
	    	  firstDone=true;
	  	}
		else if(!secondDone)
	  	{
	    	  second = atof(scalar.c_str());
	    	  result.push_back(std::make_pair(first,second));
	  	}
		else
		{
		  std::cout << "Config Error: " << key << " is a list of lists > 2 entries\n";
		  throw;
		}
	    }
	  }
	}
    }
    else
    {
	std::cout << "Config Error: " << key << " not found!\n";
	throw;
	return result;
    }

    return result;

}

std::vector<float> 
YamlReader::GetVectorOfFloats(std::string key)
{
    std::vector<float> result;
    if (const YAML::Node *node = doc.FindValue(key.c_str()))
    {
	if(node->Type() == YAML::NodeType::Scalar)
	{
		std::string scalar;
		*node >> scalar;
		result.push_back(atof(scalar.c_str()));
		return result;
	}
	else if(node->Type() == YAML::NodeType::Sequence)
	{
	  for(YAML::Iterator it=node->begin(); it!=node->end();++it)
	  {
		std::string scalar;
		*it >> scalar;
		result.push_back(atof(scalar.c_str()));
	  }
	  return result;
	}
	else 
	{
		std::cout << "Config Error: " << key << " is not a scalar or list!\n";
		throw;
	}
    }
    else
    {
	std::cout << "Config Error: In config file: " << key << " not found!\n";
	throw;
	return result;
    }

}

