#include "TProof.h"
#include "TDSet.h"
#include <iostream>
#include <string>
#include "TObjString.h"

using namespace std;

const char* getJson(TProof* proof)
{
  if(proof->GetOutputList()->GetEntries() == 1)
  {
    TObjString* str = dynamic_cast<TObjString*>(proof->GetOutputList()->At(0));
    return str->GetName();
  }
  else
  {
    cout << "Error: proof ouput list != 1"<< 
	proof->GetOutputList()->GetEntries()<< endl;
    return "";
  }
}

int main(int argc, char *argv[])
{

  int nEventsProcess = -1;


  TProof* proof = TProof::Open("workers=2");
  string dir = "/home/jhugon/WebHEP/";
  string inDir = string(dir).append("www/data/");
  string libLocation = string(dir).append("lib/libWebHEPSelector.so");
  
  proof->SetBit(TProof::kUsingSessionGui);
  proof->Load(libLocation.c_str());
  proof->Print(); 

  TDSet* ttbar = new TDSet("ttbar");
  TDSet* Zll = new TDSet("Zll");
  TDSet* Wlnu = new TDSet("Wlnu");
  TDSet* qcd = new TDSet("qcd");

  ttbar->Add(string(inDir).append("lhcttbar.root").c_str());
  Zll->Add(string(inDir).append("lhcZll.root").c_str());
  Wlnu->Add(string(inDir).append("lhcWlnu.root").c_str());
  qcd->Add(string(inDir).append("lhcqcd.root").c_str());

  const char* inJson = "{'datasets': {'qcd': False, 'Zll': False, 'Wlnu': False, 'ttbar': False}, 'cutSelection': {'nMu': 0, 'nEl': 0, 'nPh': 0, 'nJet': 4, 'met': 0}, 'objectSelection': {'mupt': 20, 'mueta': 2.5, 'elpt': 20, 'eleta': 2.5, 'phpt': 20, 'pheta': 2.5, 'jetpt': 30, 'jeteta': 5, 'bTagEff': 0.8, 'bTagFakeRate': 0.1}}";

  ttbar->Process("WebSelector",inJson,nEventsProcess);
  const char* ttbarJson = getJson(proof);
  Zll->Process("WebSelector",inJson,nEventsProcess);
  const char* ZllJson = getJson(proof);
  Wlnu->Process("WebSelector",inJson,nEventsProcess);
  const char* WlnuJson = getJson(proof);
  qcd->Process("WebSelector",inJson,nEventsProcess);
  const char* qcdJson = getJson(proof);

  cout << "\n\n ttbar: \n" << ttbarJson << endl;
  cout << "\n\n Zll: \n" << ZllJson << endl;
  cout << "\n\n Wlnu: \n" << WlnuJson << endl;
  cout << "\n\n qcd: \n" << qcdJson << endl;

  cout << "Done.\n";
  return 0;
}

