
#include "WebSelector.h"

#include "TProof.h"
#include "TDSet.h"
#include <iostream>

using namespace std;

int main()
{

  TChain* tree = new TChain("tree");
  //tree->AddFile("/home/jhugon/WebHEP/www/data/lhcqcd.root");
  tree->AddFile("/home/jhugon/WebHEP/www/data/lhcttbar.root");

  //TFile* outFile = new TFile("proofProtoTest.root","RECREATE");
  //outFile->SetName("outFile");

  WebSelector select;

  TList* inList = new TList();
  //inList->Add(outFile);

  select.SetInputList(inList);

  string inData = "{'datasets': {'qcd': False, 'Zll': False, 'Wlnu': False, 'ttbar': False}, 'cutSelection': {'nMu': 0, 'nEl': 0, 'nPh': 0, 'nJet': 4, 'met': 0}, 'objectSelection': {'mupt': 20, 'mueta': 2.5, 'elpt': 20, 'eleta': 2.5, 'phpt': 20, 'pheta': 2.5, 'jetpt': 30, 'jeteta': 5, 'bTagEff': 0.8, 'bTagFakeRate': 0.1}}";
  select.SetOption(inData.c_str());
  select.Begin(NULL);
  select.SlaveBegin(NULL);
  select.Init(tree);

  int treeSize = tree->GetEntries();
  cout << "treeSize: " << treeSize << endl;
  int nEntries = treeSize;
  int maxEvents = 1000;
  if (treeSize > maxEvents)
	treeSize = maxEvents;

  cout << "nEvents: " << treeSize << endl;
  int iPassed=0;

  for(int i=0; i<treeSize;i++)
  {
        if(!select.Process(i))
		continue;
	iPassed++;
	
  }
  select.SlaveTerminate();
  select.Terminate();

  cout << "nEventsPassed: " << iPassed << endl;
  int outputlength = select.GetOutputList()->GetEntries();
  cout << "list length: " <<outputlength<<endl;
  if(outputlength>0)
  {
    TObjString* json = (TObjString*) select.GetOutputList()->At(0);
    json->Print("");
  }

  return 0;
}


