import pyjd # this is dummy in pyjs.
from pyjamas.ui.RootPanel import RootPanel
from pyjamas.ui.Button import Button
from pyjamas.ui.HTML import HTML
from pyjamas.ui.Label import Label
from pyjamas import Window

from pyjamas.ui.SimplePanel import SimplePanel
from pyjamas.ui.HorizontalPanel import HorizontalPanel
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui import HasAlignment
from pyjamas.ui.CheckBox import CheckBox
from pyjamas.ui.TextBox import TextBox
from pyjamas.ui.FlexTable import FlexTable
from pyjamas.ui.FlowPanel import FlowPanel

from pyjamas.Timer import Timer
from pyjamas.chart.GChart import GChart
from pyjamas.chart import SymbolType

from pyjamas import log

from pyjamas.JSONService import JSONProxy
#from pyjamas.JSONParser import JSONParser
import json

import pygwt


class DatasetSelection(SimplePanel):
    def __init__(self):
        SimplePanel.__init__(self)

	vpanel = VerticalPanel(StyleName="subtable")

	self.title = Label("Include Datasets:",StyleName="subtitle")
        self.qcd = CheckBox("QCD")
        self.Zll = CheckBox("Zll")
        self.Wlnu = CheckBox("Wlnu")
        self.ttbar = CheckBox("ttbar")

	vpanel.add(self.title)
        vpanel.add(self.qcd)
        vpanel.add(self.Zll)
        vpanel.add(self.Wlnu)
        vpanel.add(self.ttbar)

	self.add(vpanel)

    def getJSON(self):
	tmp = {}
	tmp["qcd"] = self.qcd.isChecked()
	tmp["Zll"] = self.Zll.isChecked()
	tmp["Wlnu"] = self.Wlnu.isChecked()
	tmp["ttbar"] = self.ttbar.isChecked()
	return tmp

class ObjectSelection(SimplePanel):
    def __init__(self):
        SimplePanel.__init__(self)

	table = FlexTable(StyleName="subtable")

	self.title = Label("Physics Object Cuts:",StyleName="subtitle")
	table.setWidget(0,0,self.title)

        self.mupt = TextBox(StyleName="textentry")
	self.mupt.setText("20")
	table.setText(1,0,"Muon Pt (GeV) > ")
	table.setWidget(1,2,self.mupt)

        self.mueta = TextBox(StyleName="textentry")
	self.mueta.setText("2.5")
	table.setText(2,0,"Muon |Eta| < ")
	table.setWidget(2,2,self.mueta)

        self.elpt = TextBox(StyleName="textentry")
	self.elpt.setText("20")
	table.setText(3,0,"Electron Pt (GeV) > ")
	table.setWidget(3,2,self.elpt)

        self.eleta = TextBox(StyleName="textentry")
	self.eleta.setText("2.5")
	table.setText(4,0,"Electron |Eta| < ")
	table.setWidget(4,2,self.eleta)

        self.phpt = TextBox(StyleName="textentry")
	self.phpt.setText("20")
	table.setText(5,0,"Photon Pt (GeV) > ")
	table.setWidget(5,2,self.phpt)

        self.pheta = TextBox(StyleName="textentry")
	self.pheta.setText("2.5")
	table.setText(6,0,"Photon |Eta| < ")
	table.setWidget(6,2,self.pheta)

        self.jetpt = TextBox(StyleName="textentry")
	self.jetpt.setText("50")
	table.setText(7,0,"Jet Pt (GeV) > ")
	table.setWidget(7,2,self.jetpt)

        self.jeteta = TextBox(StyleName="textentry")
	self.jeteta.setText("5.0")
	table.setText(8,0,"Jet |Eta| < ")
	table.setWidget(8,2,self.jeteta)

        self.bTagEff = TextBox(StyleName="textentry")
	self.bTagEff.setText("0.8")
	table.setText(9,0,"b-Tag Efficiency = ")
	table.setWidget(9,2,self.bTagEff)

        self.bTagFakeRate = TextBox(StyleName="textentry")
	self.bTagFakeRate.setText("0.1")
	table.setText(10,0,"b-Tag Fake Rate = ")
	table.setWidget(10,2,self.bTagFakeRate)

	self.add(table)

    def getJSON(self):
	tmp = {}
	tmp["mupt"] = float(self.mupt.getText())
	tmp["mueta"] = float(self.mueta.getText())
	tmp["elpt"] = float(self.elpt.getText())
	tmp["eleta"] = float(self.eleta.getText())
	tmp["phpt"] = float(self.phpt.getText())
	tmp["pheta"] = float(self.pheta.getText())
	tmp["jetpt"] = float(self.jetpt.getText())
	tmp["jeteta"] = float(self.jeteta.getText())
	tmp["bTagEff"] = float(self.bTagEff.getText())
	tmp["bTagFakeRate"] = float(self.bTagFakeRate.getText())
	return tmp

class CutSelection(SimplePanel):
    def __init__(self):
        SimplePanel.__init__(self)

	table = FlexTable(StyleName="subtable")

	self.title = Label("Selection Cuts:",StyleName="subtitle")
	table.setWidget(0,0,self.title)

        self.nMu = TextBox(StyleName="textentry")
	self.nMu.setText("0")
	#self.nMu.setWidth("15")
	table.setText(1,0,"N Muons >= ")
	table.setWidget(1,2,self.nMu)

        self.nEl = TextBox(StyleName="textentry")
	self.nEl.setText("0")
	table.setText(2,0,"N Electrons >= ")
	table.setWidget(2,2,self.nEl)

        self.nPh = TextBox(StyleName="textentry")
	self.nPh.setText("0")
	table.setText(3,0,"N Photons >= ")
	table.setWidget(3,2,self.nPh)

        self.nJet = TextBox(StyleName="textentry")
	self.nJet.setText("0")
	table.setText(4,0,"N Jets >= ")
	table.setWidget(4,2,self.nJet)

        self.met = TextBox(StyleName="textentry")
	self.met.setText("0")
	table.setText(5,0,"Met (GeV) >= ")
	table.setWidget(5,2,self.met)

	self.add(table)

    def getJSON(self):
	tmp = {}
	tmp["nMu"] = int(self.nMu.getText())
	tmp["nEl"] = int(self.nEl.getText())
	tmp["nPh"] = int(self.nPh.getText())
	tmp["nJet"] = int(self.nJet.getText())
	tmp["met"] = float(self.met.getText())
	return tmp

class WaitingTimer(Timer,Label):
    def __init__(self, countdown_val):
        Timer.__init__(self)
	Label.__init__(self,"")

        # save the countdown value
        self.countdown = countdown_val
	self.start = True
        self.schedule(10)

    def run(self):

        # When subclassing, we just implement the run method

        # update the countdown
        self.setText('Job Running for ' +
                     str(self.countdown) + " seconds")
        # reschdule if we're not to zero else create the popup
        self.countdown += 1
        if self.countdown >= 0:
            self.schedule(1000)
        else:
	    Window.alert("Job Done.")

class Histo(GChart):
    def __init__(self,xBinLowEdges,binContents,xlabel):
	#log.writebr("Log: Histo.__init__: Starting")

	histNameDict = {
		"ptMu1":"Leading Muon Pt (GeV)",
		"ptEl1":"Leading Electron Pt (GeV)",
		"ptPh1":"Leading Photon Pt (GeV)",
		"ptJet1":"Leading Jet Pt (GeV)",
		"histMet":"Missing Transverse Momentum (MET) (GeV)",
		"histHt":"Scalar Jet Energy Sum (HT) (GeV)",
		"histSt":"Scalar Physics Object Energy Sum (ST) (GeV)",
		"histM":"Invariant Mass of Visible Objects (GeV)",
		"histSmin":"Sqrt(Smin) (GeV)",
		"histMDiEl":"Di-Electron Invariant Mass (GeV)",
		"histMDiMu":"Di-Muon Invariant Mass (GeV)",
		"histMDiJet":"Di-Jet Invariant Mass (GeV)",
		"histMDiPh":"Di-Photon Invariant Mass (GeV)",
		}

	if len(xBinLowEdges)!=len(binContents):
	  log.writebr("Error: Histo.__init__: x and y have different lengths")
	  assert(len(xBinLowEdges)==len(binContents))
        GChart.__init__(self)
        #self.setChartTitle("<b>Pt Histogram</b>")
        self.setChartSize(250, 250)
        self.addCurve()
	width = xBinLowEdges[1]-xBinLowEdges[0]
        for i in range(len(xBinLowEdges)-1):
	    #RootPanel().add(Label("x: "+str(xBinLowEdges[i]+width/2.)+", y: "+str(binContents[i])))
            self.getCurve().addPoint(xBinLowEdges[i]+width/2.,binContents[i])
        self.getCurve().getSymbol().setSymbolType(SymbolType.VBAR_SOUTH)
        self.getCurve().getSymbol().setBackgroundColor("red")
        self.getCurve().getSymbol().setBorderColor("black")
        self.getCurve().getSymbol().setModelWidth(width)

	xAxisLabel = HTML(histNameDict[xlabel],StyleName="xlabel")
	yAxisLabel = HTML("Events",StyleName="ylabel")
        self.getXAxis().setAxisLabel(xAxisLabel)
        self.getYAxis().setAxisLabel(yAxisLabel)

	thickness = self.getYAxis().getTickLabelThickness()
	#log.writebr("Log: Histo.__init__: tick Label thickness: "+str(thickness))
	self.getYAxis().setTickLabelThickness(thickness/3.)

        self.getXAxis().setTickLabelFormat("#")
        self.getYAxis().setTickLabelFormat("#")
        self.getXAxis().setTickCount(7)
        self.getYAxis().setTickCount(7)
	self.update()

class AnalyzerService(JSONProxy):
    def __init__(self):
	JSONProxy.__init__(self, "services/AnalyzerService.py",["echo","makeHistos"])

class AnalyzerSetupPage(SimplePanel):
    def __init__(self):
        SimplePanel.__init__(self)

        self.panel = FlexTable(StyleName="roottable")
	cellFormatter = self.panel.getFlexCellFormatter()
	rowFormatter = self.panel.getRowFormatter()

	self.datasets = DatasetSelection()
	self.cutSelection = CutSelection()
	self.objectSelection = ObjectSelection()
	self.startButton = Button("Start",getattr(self,"makeJSON"),StyleName="button")

	self.panelTitle = Label("WebHEP -> Analyzer Setup",StyleName="title")
        self.panel.setWidget(0,0,self.panelTitle)
	cellFormatter.setColSpan(0,0,3)
	cellFormatter.setHorizontalAlignment(0,0,HasAlignment.ALIGN_CENTER)
        self.panel.setWidget(1,0,self.datasets)
	self.panel.setWidget(1,1,self.cutSelection)
        self.panel.setWidget(1,2,self.objectSelection)
	self.panel.setWidget(2,0,self.startButton)
	cellFormatter.setColSpan(2,0,3)
	cellFormatter.setHorizontalAlignment(2,0,HasAlignment.ALIGN_CENTER)

        self.add(self.panel)

	self.json = {}
	self.analyzerService = AnalyzerService()

    def makeJSON(self):
        #Window.alert("Making JSON")
	self.json["datasets"] = self.datasets.getJSON()
	self.json["cutSelection"] = self.cutSelection.getJSON()
	self.json["objectSelection"] = self.objectSelection.getJSON()
	debugLabel = Label(str(self.json))
	#RootPanel().add(debugLabel)
	#self.waitPage()
	#self.plotsPage()
	idNum = self.analyzerService.makeHistos(self.json,self)
	#idNum = self.analyzerService.echo(self.json,self)
	self.waitPage()

    def waitPage(self):
	self.waitingTimer = WaitingTimer(0)
	self.panel.clear()
	self.panel.setText(0,0,"Running...")
	self.panel.setWidget(1,0,self.waitingTimer)
	self.panel.setText(2,0,"Settings:")
	self.panel.setText(3,0,str(self.json))

    def plotsPage(self,jsondata):
	#log.writebr("Log: plotsPage: Starting")
	self.remove(self.panel)
	self.clear()
	self.panel = VerticalPanel()
	self.plotsTitle = Label("WebHEP Results",StyleName="title")
	self.panel.add(self.plotsTitle)
	self.flowPanel = FlowPanel(Width="90%",StyleName="flow-panel")

	#log.writebr("logMessage: "+str(jsondata))

	self.histos = []
	for key in jsondata:
	  #log.writebr("logMessage: "+str(key))
	  histInfo = jsondata[key]
	  y = histInfo["y"]
	  x = histInfo["x"]
	  x = x[:len(x)-1]
	  self.histos.append(Histo(x,y,key))
	
	for iPlot in range(len(self.histos)):
	  self.flowPanel.add(self.histos[iPlot])

	configLabel = Label(self.json)
	resultsLabel = Label(str(jsondata))

	self.panel.add(self.flowPanel)
	self.panel.add(configLabel)
	self.panel.add(resultsLabel)
	self.add(self.panel)
	#log.writebr("Log: plotsPage: Done")

    def onRemoteResponse(self, response, request_info):
	#log.writebr("Log: onRemoteResponse: Starting")
	self.plotsPage(json.loads(response))

    def onRemoteError(self, code, errobj, request_info):
	self.clear()
	self.add(Label("There was an error in the creation of analysis plots. \n\n\nRemote Server Error: %i \n %s" % (code, errobj)))

if __name__ == '__main__':
    #pyjd.setup("public/Hello.html?fred=foo#me")
    pyjd.setup("http://localhost/examples/jhugon/public/Hello.html?fred=foo#me")
    
    analyzerSetup = AnalyzerSetupPage()
    RootPanel().add(analyzerSetup)

    pyjd.run()
