#!/usr/bin/env python

import json
import time
import sys
import scipy
import WebHEP

from jsonrpc import ServiceMethod

class Service:
    @ServiceMethod
    def echo(self, msg):
	time.sleep(5)
	sys.stderr.write(str(msg))
	sys.stderr.write("\n")
	sys.stderr.write(str(type(msg)))
	sys.stderr.write("\n")
        return msg

    @ServiceMethod
    def makeHistos(self, msg):
	sys.stderr.write("starting makeHistos...\n")
	injson = json.dumps(msg)

	#sys.stderr.write("msg type is: "+str(type(msg))+"\n")
	#sys.stderr.write("msgjson type is: "+str(type(injson))+"\n")

	result = WebHEP.run(injson)
	#result = WebHEP.test(injson)
	#result = WebHEP.test3(injson)
	#result = WebHEP.test4(injson)

	"""
	resultDict = json.loads(result)

	sys.stderr.write("resultDict: "+str(resultDict)+"\n")
	sys.stderr.write("resultDict type: "+str(type(resultDict))+"\n")

	result = json.dumps(resultDict["ttbar"])

	sys.stderr.write("result: "+str(result)+"\n")
	sys.stderr.write("result type: "+str(type(result))+"\n")

	result = {"ptMu":{"x":[0,1,2,3,4,5],"y":[0,1,2,3,4,5]}}
	#result = json.dumps(result)
	"""
	sys.stderr.write("result: "+str(result)+"\n")
	sys.stderr.write("result type: "+str(type(result))+"\n")
	sys.stderr.write("makeHistos: returning\n")
	return result

    @ServiceMethod
    def makeHistosDummy(self, msg):
	#sys.stderr.write("starting makeHistos...")

	x = scipy.linspace(1.0,1000,num=15)
	y1 = x*x
	y2 = x
	y3 = scipy.ones(x.shape)
	y3 *= 10.0
	
	resultDict = {}
	resultDict["Mu Pt (GeV)"] = {"x": list(x), "y": list(y1)}
	resultDict["Mu |Eta|"] = {"x": list(x), "y": list(y2)}
	resultDict["Mu Phi"] = {"x": list(x), "y": list(y3)}
	#resultJson = json.dumps(resultDict)
	return resultJson

if __name__ == '__main__':
    # this is if JSONService.py is run as a CGI
    from jsonrpc.cgiwrapper import handleCGI
    handleCGI(Service())
else:
    # this is if JSONService.py is run from mod_python:
    # rename .htaccess.mod_python to .htaccess to activate,
    # and restart Apache2
    from jsonrpc.modpywrapper import handler 
